#!/usr/bin/ruby

require "rubygems"
require "knjdbrevision"
require "knj/autoload"
Knj::Os.chdir_file(__FILE__)

begin
  options = {
    :dbargs => {
      :return_keys => "symbols"
    }
  }
  
  OptionParser.new do |opts|
    opts.banner = "Usage: example.rb [options]"
    
    opts.on("-t DBTYPE", "--type DBTYPE", "This database type.") do |t|
      options[:type] = t
    end
    
    opts.on("-d DBKEY=DBVALUE", "--dbarg DBKEY=DKVALUE", "Sets another database config key and value.") do |val|
      split_data = val.split("=")
      options[:dbargs][split_data.first.to_sym] = split_data.last
    end
    
    opts.on("-s FILEPATH", "A file with JSON content which contains the schema.") do |s|
      options[:schema_file] = s
      options[:schema] = JSON.parse(File.read(s))
    end
    
    opts.on("-r FILEPATH", "A Ruby file which sets the global variable $tables which contains the schema.") do |val|
      options[:rb_schema_file] = val
      require val
      options[:schema] = $tables
    end
  end.parse!
rescue OptionParser::InvalidOption => e
  print "#{e.message}\n"
  exit
end

dbrev.init_db(
  options[:schema],
  Knjdbrevision.new
)